<template>
  <div class="mx-3 mb-5">
    <v-card 
        elevation="3"
        class="px-3"
            min-width="250px">
        <v-card-title class="justify-space-between">
            <h3 class="mr-2">{{this.todoItem.title}}</h3>
            <v-chip 
                small
                class="font-weight-bold"  
                :class=" (todoItem.isActive)? 'info': 'error'">
                {{this.textstatus}}
            </v-chip> 
        </v-card-title>
        <v-card-text>
            <v-textarea
                readonly
                no-resize
                rows="3"
                hide-details = "false"
                v-model="todoItem.description">
            </v-textarea>
        </v-card-text>
        <v-card-actions class="justify-center">
            <v-btn 
                class="mr-1 btn-primary" 
                small 
                :loading="loader"
                @click="showModel"><v-icon>mdi-pencil</v-icon></v-btn>
            <v-btn 
                class="ml-1 error" 
                small 
                :loading="loader"
                @click="confirmation = true"><v-icon>mdi-delete</v-icon></v-btn>
        </v-card-actions>
    </v-card>
    <v-dialog 
        v-model="dialog" 
        width="800px"
        persistent>
        <UpdateTodo 
            @closeDialog="closeModel" 
            @reloadList="reloadTodo"
            @showAlert="showAlert"
            v-if="dialog" 
            :todoId="todoItem._id"/>
    </v-dialog>
    <v-dialog
        light
        width="300px"
        v-model="confirmation">
        <v-card class="py-5">
            <v-card-text>Are you sure you want to delete this record?</v-card-text>
            <v-card-actions class="justify-end">
                <v-btn class="mx-2" small @click="removeTodo">Yes</v-btn>
                <v-btn class="mx-2" small @click="confirmation = false">No</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
    props : ['todoItem'],
    data(){
        return{
            title: "",
            desc: "",
            status: "",
            loader: false,
            dialog: false,
            confirmation: false,
            textstatus : (this.todoItem.isActive)? "Active": "Inactive"
        }
    },
    methods: {
        showModel(){
            this.dialog = true;
        },
        closeModel(){
            this.dialog = false;
        },
        removeTodo(){
            this.confirmation = false;
            this.loader = true;
            this.$axios.delete('/todo/'+this.todoItem._id)
                .then((resp) => {
                    if (resp.statusCode && resp.statusCode == 400){
                            this.$emit('showAlert', {type: "error", text: resp.message});
                        }
                        else{
                            this.$emit('showAlert', {type: "success", text: "Remove Success"});
                            this.$emit('reloadList');
                        }
                })
                .catch((err) =>{
                    alert(err);
                    console.log(err);
                });
        },
        reloadTodo(){
            this.$emit('reloadList');
        },
        showAlert(data){
            this.$emit('showAlert', data);
        }
    }
}
</script>

<style>

</style>